package o.e.r.tim.testing;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.recommenders.stats.rcp.interfaces.IDeveloperActivityPage;
import org.eclipse.recommenders.stats.rcp.interfaces.ITreeCategory;
import org.eclipse.recommenders.stats.rcp.interfaces.ITreeViewerExtension;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

public class MyClass implements ITreeViewerExtension {

    private static final String MY_PAGE = "My Page";
    private static Composite parent;

    @Override
    public String getTreeItemText() {
        return MY_PAGE;
    }

    @Override
    public ITreeCategory getCategory() {

        ITreeCategory treeCategory = new ITreeCategory() {

            private String name;
            private List<String> items = new ArrayList<String>();

            @Override
            public String getName() {
                return name;
            }

            @Override
            public void setName(String value) {
                name = value;
            }

            @Override
            public List<String> getItems() {
                return items;
            }

            @Override
            public String toString() {
                return name;
            }
        };

        treeCategory.setName(MY_PAGE);
        treeCategory.getItems().add("First Test Item");

        return treeCategory;
    }

    @Override
    public IDeveloperActivityPage getPage() {
        IDeveloperActivityPage page = new IDeveloperActivityPage() {

            @Override
            public Composite getComposite() {
                return parent;
            }

            @Override
            public void createContent(Composite detailCmp) {
                parent = createWrapperComposite(detailCmp);

                Label label = new Label(parent, SWT.None);
                label.setText("My Extension Point Page: Yeaaaaaaa .... that rules !!!!");
                label.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true));
            }

            private Composite createWrapperComposite(Composite detailCmp) {
                Composite newComp = new Composite(parent, SWT.NONE);
                newComp.setLayout(new GridLayout());
                newComp.setLayoutData(new GridData(GridData.FILL_BOTH));
                return newComp;
            }
        };

        return page;
    }
}
